# 16-889: Learning for 3D Vision (SP22) - Assignment 2
* Name: Yen-Chi Cheng (yenchich@andrew.cmu.edu)
* AndrewID: `yenchich`

# Installation
- To setup the environment, run
```
conda create -f 16889.yml
conda activate 16889
```

# Run
To produce the outputs for each question, run
```
mkdir -p output
mkdir -p vis
python main.py
```

## Q1
```
# Q1.1
python fit_data.py --type 'vox'

# Q1.2
python fit_data.py --type 'point' --max_iter 20000

# Q1.3
python fit_data.py --type 'mesh' --max_iter 20000
```

## Q2

```
# Q2.1
python train_model.py --type 'vox' --batch_size 32 # train
python eval_model.py --type 'vox' --load_checkpoint --ckpt_path logs/2.1-vox/checkpoint_vox-8000.pth # eval
```

```
# Q2.2
python train_model.py --type 'point' --batch_size 32 # train
python eval_model.py  --type 'point' --load_checkpoint --ckpt_path logs/2.2-pcd/checkpoint_point-8000.pth # eval
```

```
# Q2.3
python train_model.py --type 'mesh' --batch_size 32 # train
python eval_model.py --type 'mesh' --load_checkpoint --ckpt_path logs/2.3-mesh-n_points_5000-w_chamfer-10.0/checkpoint_mesh-8000.pth # eval
```

```
# eval all
CUDA_VISIBLE_DEVICES=1 python eval_model.py --type 'vox' --load_checkpoint --ckpt_path logs/2.1-vox/checkpoint_vox-8000.pth && python eval_model.py  --type 'point' --load_checkpoint --ckpt_path logs/2.2-pcd/checkpoint_point-8000.pth && python eval_model.py --type 'mesh' --load_checkpoint --ckpt_path logs/2.3-mesh-n_points_5000-w_chamfer-10.0/checkpoint_mesh-8000.pth
```

```
# Q2.5
CUDA_VISIBLE_DEVICES=0 python train_model.py --type 'mesh' --batch_size 32 --w_chamfer 10 # train
CUDA_VISIBLE_DEVICES=1 python train_model.py --type 'mesh' --batch_size 32 --w_chamfer 0.1 # train
CUDA_VISIBLE_DEVICES=1 python train_model.py --type 'mesh' --batch_size 32 --w_chamfer 1000

# eval all
python eval_model.py --type 'mesh' --load_checkpoint --ckpt_path logs/2.3-mesh-n_points_5000-w_chamfer-0.1/checkpoint_mesh-8000.pth && python eval_model.py --type 'mesh' --load_checkpoint --ckpt_path logs/2.3-mesh-n_points_5000-w_chamfer-10.0/checkpoint_mesh-8000.pth && python eval_model.py --type 'mesh' --load_checkpoint --ckpt_path logs/2.3-mesh-n_points_5000-w_chamfer-1000.0/checkpoint_mesh-8000.pth
```

```
# Q2.6
python q2.6_eval_model.py --type 'vox' --load_checkpoint --ckpt_path logs/2.1-vox/checkpoint_vox-8000.pth # compute f1 at different threshold
```


```
# Q3.1
python train_model.py --type 'vox-implicit' --batch_size 16 --w_chamfer 10 # train
python eval_model.py --type 'vox-implicit' --load_checkpoint --ckpt_path logs/3.1-vox-implicit-n_points_5000-w_chamfer-10.0/checkpoint_vox-implicit-8000.pth
```